#!/usr/bin/perl

##-------------------------------------------------------------------#
## %PS
##    
## Licensed Internal Code - Property of IBM
##    
## 2105/1750/2107 Licensed Internal Code
##    
## (C) Copyright IBM Corp. 2000, 2006 All Rights Reserved.
##    
## US Government Users Restricted Rights - Use, duplication or
## disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
## %EPS
##
## COMPONENT_NAME (MDM RM)
##
## Function: checkUser.sh <Username> <Password>
##
## Description: This authenticate the give username and password
##		against the OS system.
##
## Change History:
##   Modifier			Date			Change ID
##-------------------------------------------------------------------#
##  Todd Schlomer		05/19/2006
##      Initial version
##-------------------------------------------------------------------#
## End of PROLOG

# args passed in as:  <Username> <Password>
my($USR, $PWD) = @ARGV;

# check for invalid inputs
if ($USR eq '') {
	print "Please provide a username:\r\n";
	print "$0 <Username> <Password>\r\n";
	exit -1;
}
if ($PWD eq '') {
	print "Please provide a password:\r\n";
	print "$0 <Username> <Password>\r\n";
	exit -1;
}

#
# Get the user information from the system. Then crypt the give password with the salt
# for the authentication check.
#
my ($usr_name, $usr_passwd, $usr_uid, $usr_gid, $usr_quota, 
	$usr_comment, $usr_gcos, $usr_dir, $usr_shell) = getpwnam("$USR") ;
$SALT = $usr_passwd;
if ($SALT eq '') {
	print "Invalid username\r\n";
	exit -1;
}
$HASH = crypt($PWD, $SALT);

#
# Compare both hashes. If they match we have a valid login
#
if ($HASH eq $SALT) {
	print "Authentication succeeded\r\n";
	exit 0;
} else {
	print "Authentication failed\r\n";
	exit 4;
}
